package de.skyrix.modules.actions.portlets;
import java.io.IOException;
import java.net.MalformedURLException;
import java.text.DateFormat;
import java.util.Locale;

import org.apache.jetspeed.modules.actions.portlets.JspPortletAction;
import org.apache.jetspeed.portal.Portlet;
import org.apache.turbine.util.Log;
import org.apache.turbine.util.RunData;

import skyrix.Appointment;
import skyrix.AppointmentManager;
/**
 * @author buhle
 *
 * Dient zum anlegen neuer Termine
 */
public class NewAppointment extends JspPortletAction
{
  protected void buildNormalContext(Portlet portlet, RunData rundata)
	{
    PortletProperties pp = new PortletProperties();
    boolean isSkyrixUser = true;
    
    try
    {
      Client client = new Client(pp.getHost(), rundata.getUser().getUserName(), rundata.getUser().getPassword());
      AppointmentManager am = new AppointmentManager(client.getClient());
      am.getAllAppointments(new java.util.Date(), null);
    }
   catch (Exception e)
   {
     isSkyrixUser = false;
   }
   
   rundata.getRequest().setAttribute("isSkyrixUser", new Boolean(isSkyrixUser));
	}
  
	public void doRefresh(RunData rundata, Portlet portlet)
	{
    boolean isSkyrixUser = true;

		try
    {
      String title = rundata.getParameters().getString("title");
      String location = rundata.getParameters().getString("location");
		  String comment = rundata.getParameters().getString("comment");
		  String startdate = rundata.getParameters().getString("start_date");
		  String enddate = rundata.getParameters().getString("end_date");
      startdate = startdate+" "+rundata.getParameters().getString("start_hour")+":"+rundata.getParameters().getString("start_minute");
      enddate = enddate+" "+rundata.getParameters().getString("end_hour")+":"+rundata.getParameters().getString("end_minute");

      AppointmentManager am = null;
      PortletProperties pp = new PortletProperties();
    
      Locale loc = new Locale("de", "DE");
      DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT, loc);
      java.util.Date begin = df.parse(startdate);
      java.util.Date end = df.parse(enddate);

      Client client = new Client(pp.getHost(), rundata.getUser().getUserName(), rundata.getUser().getPassword());
      am = new AppointmentManager(client.getClient());
      Appointment ap = new Appointment(null, title, location, comment, begin, end);
      am.insertAppointment(ap);
//      Log.debug("Termin angelegt: "+startdate+" - "+enddate+" / "+title+" / "+comment);
    }
    catch (MalformedURLException ex)
    {
      Log.error(ex);
    }
    catch (IOException ex)
    {
      Log.error(ex);
    }
    catch (Exception ex)
    {
      Log.error(ex);
    }
    
    rundata.getRequest().setAttribute("isSkyrixUser", new Boolean(isSkyrixUser));
	}
}
