package de.skyrix.modules.actions.portlets;
import java.io.IOException;
import java.net.MalformedURLException;
import java.text.DateFormat;
import java.util.Locale;

import org.apache.jetspeed.modules.actions.portlets.JspPortletAction;
import org.apache.jetspeed.portal.Portlet;
import org.apache.turbine.util.Log;
import org.apache.turbine.util.RunData;

import skyrix.Job;
import skyrix.JobManager;
/**
 * @author buhle
 *
 * Dient zum anlegen neuer Termine
 */
public class NewJob extends JspPortletAction
{
  protected void buildNormalContext(Portlet portlet, RunData rundata)
  {
    PortletProperties pp = new PortletProperties();
    boolean isSkyrixUser = true;
    
    try
    {
      Client client = new Client(pp.getHost(), rundata.getUser().getUserName(), rundata.getUser().getPassword());
      JobManager jm = new JobManager(client.getClient());
      jm.getAllJobs(new java.util.Date(), null);
    }
   catch (Exception e)
   {
     isSkyrixUser = false;
   }
   
   rundata.getRequest().setAttribute("isSkyrixUser", new Boolean(isSkyrixUser));
  }

  public void doUpdate(RunData rundata, Portlet portlet)
  {
    boolean isSkyrixUser = true;

    try
    {
      String name = rundata.getParameters().getString("name");
      String startdate = rundata.getParameters().getString("start_date");
      String enddate = rundata.getParameters().getString("end_date");
//      startdate = startdate+" "+rundata.getParameters().getString("start_hour")+":"+rundata.getParameters().getString("start_minute");
//      enddate = enddate+" "+rundata.getParameters().getString("end_hour")+":"+rundata.getParameters().getString("end_minute");
      String priority = rundata.getParameters().getString("priority");
      String category = rundata.getParameters().getString("category");
//      Log.debug("start_date="+startdate+" |  end_date="+enddate);

      JobManager jm = null;
      PortletProperties pp = new PortletProperties();
    
      Locale loc = new Locale("de", "DE");
      DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT, loc);
      java.util.Date begin = df.parse(startdate);
      java.util.Date end = df.parse(enddate);

      Client client = new Client(pp.getHost(), rundata.getUser().getUserName(), rundata.getUser().getPassword());
      jm = new JobManager(client.getClient());
      Job job = new Job(null, name, begin, end, null, category, priority);
      jm.insertJob(job);
//      Log.debug("Job angelegt: "+startdate+" - "+enddate+" / "+name);
    }
    catch (MalformedURLException ex)
    {
      Log.debug(ex.toString());
    }
    catch (IOException ex)
    {
      Log.debug(ex.toString());
    }
    catch (Exception ex)
    {
      Log.debug(ex.toString());
    }

    rundata.getRequest().setAttribute("isSkyrixUser", new Boolean(isSkyrixUser));
  }
}
