package de.skyrix.modules.actions.portlets;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;

import org.apache.jetspeed.modules.actions.portlets.JspPortletAction;
import org.apache.jetspeed.portal.Portlet;
import org.apache.jetspeed.util.PortletSessionState;
import org.apache.turbine.util.Log;
import org.apache.turbine.util.RunData;

import skyrix.AppointmentManager;
/**
 * @author buhle 
 *
 * Liest alle Termine aus und gibt die erhaltene Collection von Terminen an
 * showAppointments.jsp weiter.
 */
public class ShowAppointments extends JspPortletAction
{
	/**
	 * Standardmethode, die automatisch vor Aufruf der JSP-Seite abgearbeitet wird bei Portlets
	 * 
	 * @see org.apache.jetspeed.modules.actions.portlets.JspPortletAction#buildNormalContext(Portlet, RunData)
	 */
	protected void buildNormalContext(Portlet portlet, RunData rundata)
	{
		AppointmentManager am = null;
    PortletProperties pp = new PortletProperties();
    
    try
		{
			int fault = 0;
      int iLines = 10;
      int actLines = 0;
      
      if ((String)PortletSessionState.getAttributeWithFallback(portlet, rundata, "act_lines") != null)
        actLines = Integer.parseInt((String)PortletSessionState.getAttributeWithFallback(portlet, rundata, "act_lines"));

      // Minustage werden ausgelesen
			int iBegin = Integer.parseInt((String) PortletSessionState.getAttributeWithFallback( portlet, rundata, "startdate"));
			// Plustage werden ausgelesen
			int iEnd = Integer.parseInt((String) PortletSessionState.getAttributeWithFallback(portlet, rundata, "enddate"));
			// Verbindung aufbauen 
      try
  		{
				Client client = new Client(pp.getHost(), rundata.getUser().getUserName(), rundata.getUser().getPassword());
				am = new AppointmentManager(client.getClient());
			}
      catch (MalformedURLException ex)
      {
        Log.debug(ex.toString());
        fault = 1;
      }
      catch (IOException ex)
      {
        Log.debug(ex.toString());
        fault = 2;
  		}
      
			// Start- und Enddatum werden bestimmt  
			Calendar begin = Calendar.getInstance();
      Calendar end = Calendar.getInstance();
      begin.add(Calendar.DAY_OF_YEAR, iBegin);
      end.add(Calendar.DAY_OF_YEAR, iEnd);
      
//			Log.debug("appoinments: " + begin.getTime() + " - " + end.getTime());
      
			// Alle Termine werden geholt.
      Collection collection = am.getAllAppointments(begin.getTime(), end.getTime());
      ArrayList appointmentList = null;
      
      // Bildet aus der Collection eine ArrayList die nur die aktuell angezeigten Termine enthlt
      boolean next = true;
      boolean prior = true;
      int endLines = 0;
      if (collection != null)  
      {
        appointmentList = new ArrayList(collection);
        // Nur wenn die anzuzeigenden Zeilen nicht grsser sind als die existierenden Termine
        if (appointmentList.size() > iLines)
        {
          ArrayList dummy = new ArrayList();
          if (actLines+iLines < appointmentList.size())
          {
            endLines = actLines+iLines;
            if (actLines == 0) prior = false;
          }
          else 
          {
            endLines = appointmentList.size();
            next = false;
          }
          // Die ArrayList wird erstellt.
          for (int i=actLines;i<endLines;i++)
          {
            dummy.add(appointmentList.get(i));
          }
          appointmentList = dummy;
        }
        // Es gibt keine vorherigen oder weiteren Termine die angezeigt werden mssten.
        else 
        {
          next = false;
          prior = false;
        } 
      }

			// Es werden die bentigten Daten der JSP-Seite als Attribute in ihr hinterlegt. 
			rundata.getRequest().setAttribute("appointments", appointmentList);
      rundata.getRequest().setAttribute("fault", new Integer(fault));
      rundata.getRequest().setAttribute("skyrix_link", pp.getSkyrixLink());
      rundata.getRequest().setAttribute("act_lines", new Integer(endLines));
      rundata.getRequest().setAttribute("lines", new Integer(iLines));
      rundata.getRequest().setAttribute("hasNext", new Boolean(next));
      rundata.getRequest().setAttribute("hasPrior", new Boolean(prior));
		}
		catch (Exception e)
		{
			Log.error(e);
		}
	}
}
